from shlex import quote


def bash_name(name):
    name = name.replace('<', '_')
    name = name.replace('>', '_')
    name = name.replace('-', '_')
    name = name.replace(' ', '_')
    return '_' + name

def bash_value(value):
    if value is None:
        return ''
    if type(value) is bool:
        return 'true' if value else 'false'
    if type(value) is int:
        return str(value)
    if type(value) is str:
        return quote(value)
    if type(value) is list:
        return '(%s)' % ' '.join(bash_value(v) for v in value)
    raise Exception('Unknown value type %s' % type(value))

def bash_array_value(value):
    if value is None or value == '':
        return "''"
    if type(value) is bool:
        return 'true' if value else 'false'
    if type(value) is int:
        return str(value)
    if type(value) is str:
        return quote(value)
    if type(value) is list:
        raise Exception('Unable to convert list to bash array value')
    raise Exception('Unknown value type %s' % type(value))
